[06/12] perf test: Replace arm callgraph fp test workload with leafloop

Message ID 20221109174635.859406-7-namhyung@kernel.org
State New
Headers
Series perf test: Add test workloads (v1) |

Commit Message

Namhyung Kim Nov. 9, 2022, 5:46 p.m. UTC
  So that it can get rid of requirement of a compiler.

Signed-off-by: Namhyung Kim <namhyung@kernel.org>
---
 .../perf/tests/shell/test_arm_callgraph_fp.sh | 30 +------------------
 1 file changed, 1 insertion(+), 29 deletions(-)
  

Comments

Leo Yan Nov. 10, 2022, 11:20 a.m. UTC | #1
Hi Namyung,

On Wed, Nov 09, 2022 at 09:46:29AM -0800, Namhyung Kim wrote:
> So that it can get rid of requirement of a compiler.
> 
> Signed-off-by: Namhyung Kim <namhyung@kernel.org>
> ---
>  .../perf/tests/shell/test_arm_callgraph_fp.sh | 30 +------------------
>  1 file changed, 1 insertion(+), 29 deletions(-)
> 
> diff --git a/tools/perf/tests/shell/test_arm_callgraph_fp.sh b/tools/perf/tests/shell/test_arm_callgraph_fp.sh
> index ec108d45d3c6..9d6d1b2d99c5 100755
> --- a/tools/perf/tests/shell/test_arm_callgraph_fp.sh
> +++ b/tools/perf/tests/shell/test_arm_callgraph_fp.sh
> @@ -4,44 +4,16 @@
>  
>  lscpu | grep -q "aarch64" || exit 2
>  
> -if ! [ -x "$(command -v cc)" ]; then
> -	echo "failed: no compiler, install gcc"
> -	exit 2
> -fi
> -
>  PERF_DATA=$(mktemp /tmp/__perf_test.perf.data.XXXXX)
> -TEST_PROGRAM_SOURCE=$(mktemp /tmp/test_program.XXXXX.c)
> -TEST_PROGRAM=$(mktemp /tmp/test_program.XXXXX)
> +TEST_PROGRAM="perf test -w leafloop"
>  
>  cleanup_files()
>  {
>  	rm -f $PERF_DATA
> -	rm -f $TEST_PROGRAM_SOURCE
> -	rm -f $TEST_PROGRAM
>  }
>  
>  trap cleanup_files exit term int
>  
> -cat << EOF > $TEST_PROGRAM_SOURCE
> -int a = 0;
> -void leaf(void) {
> -  for (;;)
> -    a += a;
> -}
> -void parent(void) {
> -  leaf();
> -}
> -int main(void) {
> -  parent();
> -  return 0;
> -}
> -EOF
> -
> -echo " + Compiling test program ($TEST_PROGRAM)..."
> -
> -CFLAGS="-g -O0 -fno-inline -fno-omit-frame-pointer"
> -cc $CFLAGS $TEST_PROGRAM_SOURCE -o $TEST_PROGRAM || exit 1
> -
>  # Add a 1 second delay to skip samples that are not in the leaf() function
>  perf record -o $PERF_DATA --call-graph fp -e cycles//u -D 1000 --user-callchains -- $TEST_PROGRAM 2> /dev/null &
>  PID=$!

I need to append below changes, otherwise the test will fail on Arm64:

--- a/tools/perf/tests/shell/test_arm_callgraph_fp.sh
+++ b/tools/perf/tests/shell/test_arm_callgraph_fp.sh
@@ -30,11 +30,11 @@ wait $PID
 # program
 #      728 leaf
 #      753 parent
-#      76c main
+#      76c leafloop
 # ...
 
 perf script -i $PERF_DATA -F comm,ip,sym | head -n4
 perf script -i $PERF_DATA -F comm,ip,sym | head -n4 | \
        awk '{ if ($2 != "") sym[i++] = $2 } END { if (sym[0] != "leaf" ||
                                                       sym[1] != "parent" ||
-                                                      sym[2] != "main") exit 1 }'
+                                                      sym[2] != "leafloop") exit 1 }'

With appending above change, this patch looks good to me:

Reviewed-by: Leo Yan <leo.yan@linaro.org>

German, James, would you have chance to review this change?

Thanks,
Leo
  
Namhyung Kim Nov. 10, 2022, 5:45 p.m. UTC | #2
Hi Leo,

On Thu, Nov 10, 2022 at 3:20 AM Leo Yan <leo.yan@linaro.org> wrote:
>
> Hi Namyung,
>
> On Wed, Nov 09, 2022 at 09:46:29AM -0800, Namhyung Kim wrote:
> > So that it can get rid of requirement of a compiler.
> >
> > Signed-off-by: Namhyung Kim <namhyung@kernel.org>
> > ---
> >  .../perf/tests/shell/test_arm_callgraph_fp.sh | 30 +------------------
> >  1 file changed, 1 insertion(+), 29 deletions(-)
> >
> > diff --git a/tools/perf/tests/shell/test_arm_callgraph_fp.sh b/tools/perf/tests/shell/test_arm_callgraph_fp.sh
> > index ec108d45d3c6..9d6d1b2d99c5 100755
> > --- a/tools/perf/tests/shell/test_arm_callgraph_fp.sh
> > +++ b/tools/perf/tests/shell/test_arm_callgraph_fp.sh
> > @@ -4,44 +4,16 @@
> >
> >  lscpu | grep -q "aarch64" || exit 2
> >
> > -if ! [ -x "$(command -v cc)" ]; then
> > -     echo "failed: no compiler, install gcc"
> > -     exit 2
> > -fi
> > -
> >  PERF_DATA=$(mktemp /tmp/__perf_test.perf.data.XXXXX)
> > -TEST_PROGRAM_SOURCE=$(mktemp /tmp/test_program.XXXXX.c)
> > -TEST_PROGRAM=$(mktemp /tmp/test_program.XXXXX)
> > +TEST_PROGRAM="perf test -w leafloop"
> >
> >  cleanup_files()
> >  {
> >       rm -f $PERF_DATA
> > -     rm -f $TEST_PROGRAM_SOURCE
> > -     rm -f $TEST_PROGRAM
> >  }
> >
> >  trap cleanup_files exit term int
> >
> > -cat << EOF > $TEST_PROGRAM_SOURCE
> > -int a = 0;
> > -void leaf(void) {
> > -  for (;;)
> > -    a += a;
> > -}
> > -void parent(void) {
> > -  leaf();
> > -}
> > -int main(void) {
> > -  parent();
> > -  return 0;
> > -}
> > -EOF
> > -
> > -echo " + Compiling test program ($TEST_PROGRAM)..."
> > -
> > -CFLAGS="-g -O0 -fno-inline -fno-omit-frame-pointer"
> > -cc $CFLAGS $TEST_PROGRAM_SOURCE -o $TEST_PROGRAM || exit 1
> > -
> >  # Add a 1 second delay to skip samples that are not in the leaf() function
> >  perf record -o $PERF_DATA --call-graph fp -e cycles//u -D 1000 --user-callchains -- $TEST_PROGRAM 2> /dev/null &
> >  PID=$!
>
> I need to append below changes, otherwise the test will fail on Arm64:

Thanks for the fix, will add it to v2.

>
> --- a/tools/perf/tests/shell/test_arm_callgraph_fp.sh
> +++ b/tools/perf/tests/shell/test_arm_callgraph_fp.sh
> @@ -30,11 +30,11 @@ wait $PID
>  # program
>  #      728 leaf
>  #      753 parent
> -#      76c main
> +#      76c leafloop
>  # ...
>
>  perf script -i $PERF_DATA -F comm,ip,sym | head -n4
>  perf script -i $PERF_DATA -F comm,ip,sym | head -n4 | \
>         awk '{ if ($2 != "") sym[i++] = $2 } END { if (sym[0] != "leaf" ||
>                                                        sym[1] != "parent" ||
> -                                                      sym[2] != "main") exit 1 }'
> +                                                      sym[2] != "leafloop") exit 1 }'
>
> With appending above change, this patch looks good to me:
>
> Reviewed-by: Leo Yan <leo.yan@linaro.org>

Great, thanks a lot!
Namhyung


>
> German, James, would you have chance to review this change?
>
> Thanks,
> Leo
  

Patch

diff --git a/tools/perf/tests/shell/test_arm_callgraph_fp.sh b/tools/perf/tests/shell/test_arm_callgraph_fp.sh
index ec108d45d3c6..9d6d1b2d99c5 100755
--- a/tools/perf/tests/shell/test_arm_callgraph_fp.sh
+++ b/tools/perf/tests/shell/test_arm_callgraph_fp.sh
@@ -4,44 +4,16 @@ 
 
 lscpu | grep -q "aarch64" || exit 2
 
-if ! [ -x "$(command -v cc)" ]; then
-	echo "failed: no compiler, install gcc"
-	exit 2
-fi
-
 PERF_DATA=$(mktemp /tmp/__perf_test.perf.data.XXXXX)
-TEST_PROGRAM_SOURCE=$(mktemp /tmp/test_program.XXXXX.c)
-TEST_PROGRAM=$(mktemp /tmp/test_program.XXXXX)
+TEST_PROGRAM="perf test -w leafloop"
 
 cleanup_files()
 {
 	rm -f $PERF_DATA
-	rm -f $TEST_PROGRAM_SOURCE
-	rm -f $TEST_PROGRAM
 }
 
 trap cleanup_files exit term int
 
-cat << EOF > $TEST_PROGRAM_SOURCE
-int a = 0;
-void leaf(void) {
-  for (;;)
-    a += a;
-}
-void parent(void) {
-  leaf();
-}
-int main(void) {
-  parent();
-  return 0;
-}
-EOF
-
-echo " + Compiling test program ($TEST_PROGRAM)..."
-
-CFLAGS="-g -O0 -fno-inline -fno-omit-frame-pointer"
-cc $CFLAGS $TEST_PROGRAM_SOURCE -o $TEST_PROGRAM || exit 1
-
 # Add a 1 second delay to skip samples that are not in the leaf() function
 perf record -o $PERF_DATA --call-graph fp -e cycles//u -D 1000 --user-callchains -- $TEST_PROGRAM 2> /dev/null &
 PID=$!